/*
 * Copyright 1991, 1992, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include "is_types.h"

#ifndef lint
static	char	sccsid[] = "@(#)db_alloc.c	1.4	12:27:07	1/28/92";
#endif

extern	int	db_errno;

off_t
__db_alloc (file)
file_t	*file;
{
	off_t	record,
		next;
	struct	stat	stat;

	if (lseek (file->f_data_fd, 0L, 0) == -1)
		return (db_errno = DB_EIO), -1;

	if (read (file->f_data_fd, &record, sizeof record) != sizeof record)
		return (db_errno = DB_EIO), -1;

	if (record == 0) {
		if (fstat (file->f_data_fd, &stat))
			return (db_errno = DB_EIO), -1;

		record = (stat.st_size + file->f_record_size - 1) /
				file->f_record_size;
	} else {
		if (lseek (file->f_data_fd,
				record * file->f_record_size, 0) == -1)
			return (db_errno = DB_EIO), -1;

		if (read (file->f_data_fd, &next, sizeof next) != sizeof next)
			next = 0;

		if (lseek (file->f_data_fd, 0L, 0) == -1)
			return (db_errno = DB_EIO), -1;

		if (write (file->f_data_fd, &next, sizeof next) != sizeof next)
			return (db_errno = DB_EIO), -1;
	}
	return record;
}

int
__db_free (file, record)
file_t	*file;
off_t	record;
{
	off_t	next;

	if (lseek (file->f_data_fd, 0L, 0) == -1)
		return (db_errno = DB_EIO), -1;

	if (read (file->f_data_fd, &next, sizeof next) != sizeof next)
		return (db_errno = DB_EIO), -1;

	if (lseek (file->f_data_fd, record * file->f_record_size, 0) == -1)
		return (db_errno = DB_EIO), -1;

	if (write (file->f_data_fd, &next, sizeof next) != sizeof next)
		return (db_errno = DB_EIO), -1;

	if (lseek (file->f_data_fd, 0L, 0) == -1)
		return (db_errno = DB_EIO), -1;

	if (write (file->f_data_fd, &record, sizeof record) != sizeof record)
		return (db_errno = DB_EIO), -1;

	return 0;
}
