/*
 * Copyright 1992, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include <stdio.h>
#include "is_types.h"

#ifndef	lint
static	char	sccsid[] = "@(#)db_error.c	1.2	11:50:41	1/29/92";
#endif

extern	int	db_errno;

char	*db_errors[] = {
	"<No Error>",
	"I/O Error",
	"File not open",
	"Invalid argument",
	"File exists",
	"Field exists",
	"Out of memory",
	"File not empty",
	"File does not exist",
	"Field does not exist",
	"Cannot lock file",
	"Data dictionary is corrupt",
	"No current index",
	"No current record",
	"Too many fields",
	"Field does not match description",
	"Record exists",
	"Record does not exists",
	"File not found",
	"Beginning of file",
	"End of file",
	"No matching record",
	"File is locked",
};
int	db_nerrors = sizeof db_errors / sizeof (char *);

/*
 * db_error - print error message associated with db_errno
 */

db_error (s)
char	*s;
{
	int	error;
	char	*message;

	if (db_errno < DB_NOERR || db_errno >= (db_nerrors + DB_NOERR))
		error = 0;
	else
		error = db_errno - DB_NOERR;

	message = db_errors[error];
	fprintf (stderr, "%s: IDBM %s\n", s, message);
	fflush (stderr);
}
