/*
 * Copyright 1991, 1992, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include <stdio.h>
#include "is_types.h"
#include "patchlevel.h"

#ifndef lint
static	char	sccsid[] = "@(#)dbschema.c	1.3	10:33:57	2/26/92";
#endif

extern	int	is_blocksize;

/* 
 * usage - display command usage and exit
 */

usage ()
{
	fprintf (stderr, "usage: dbschema [ -V | -B blocksize ] schema\n");
	exit (1);
}

/*
 * dbschema - compile database schemas
 *
 * dbschema takes a schema file as an argument and parses the schema
 * contained there.  It creates the appropriate database files according
 * to the database description.
 */

main (argc, argv)
int	argc;
char	**argv;
{
	char	buf[BUFSIZ];
	int	flag;
	int	i;
	extern	int	optind;
	extern	char	*optarg;

	while ((flag = getopt (argc, argv, "VB:")) != EOF) {
		switch (flag) {
			case 'V':
				fprintf (stderr, "dbschema: version %s\n",
					VERSION);
				exit (1);
			case 'B':
				i = atoi (optarg);
				if ((i & (i - 1)) ||
						i < 512 || i > MAXBLOCKSIZE) {
					fprintf (stderr, "dbschema: invalid block size\n");
					exit (1);
				}
				is_blocksize = i;
				break;
		}
	}
	if (optind >= argc)
		usage ();

	if (strcmp (argv[optind], "-") != 0 &&
			freopen (argv[optind], "r", stdin) == 0) {
		sprintf (buf, "dbschema: can't open %s", argv[optind]);
		perror (buf);
		exit (1);
	}
	exit (yyparse ());
}
