/*
 * Copyright 1991, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include "is_types.h"

#ifndef lint
static	char	sccsid[] = "@(#)is_close.c	1.2	10:53:51	10/10/91";
#endif;

/*
 * isam_close - close an ISAM and free resources
 *
 *	isam_close() unlocks an ISAM file, frees up any allocated
 *	memory and flushes the ISAM buffer cache of any blocks
 *	which are associated with the file being closed.
 */

int
isam_close (file)
file_t	*file;
{
	if (file->f_locked)
		(void) isam_end_ticket (file);

	if (file->f_key_buffer) {
		free (file->f_key_buffer);
		file->f_key_buffer = 0;
	}
	(void) __isam_endbuf (file);

	(void) close (file->f_key_fd);
	(void) close (file->f_data_fd);
	file->f_key_fd = -1;
	file->f_data_fd = -1;

	return 0;
}
