#!/bin/sh
#
#	Test 11: test DBSCOMP error checking
#
#	@(#)test_11.sh	1.2	13:29:29	2/7/92
#
#	This test verifies the error messages produced by DBSCOMP.
#	Correct function is determined by running DBSCREEN on the
#	result of "make sample".
#

rm -f test_11 test_11.scr
RC=1
set -e
trap 'rm -f test_11 test_11.scr test_11.out test.out test.err ; exit $RC' 0 1 2 3 15

#
# make the screen description file
#
cat > test_11 << \EOF
database music

screen
(
Song    [aa - the name of the song that is being looked for           ]
Album   [bb - the name of the album containing the song               ]
Track   [cc - track]
Artist  [dd - the name of the performer                               ]
        [ee - the company publishing the album                        ]
)

aa foo songs field sng_title
bb file albums bar alb_title
aa file songs field sng_track
dd file
ee file publisher field pub_name

file songs file sng_album_key joining file albums field alb_album_key
file songs field sng_pub_key joint file publisher field pub_name_idx
file albums field alb_artist_key joining fiel artists field art_name_idx

screen
EOF
#
# it should have a number of compilation errors and should exit with a
# failure code
#
if ./dbscomp test_11 > test.out 2> test.err ; then
	exit
fi
if [ -s test.out ]; then
	exit
fi
cmp -s - test.err << \EOF
line 12: expected `FILE'
line 13: expected `FIELD'
line 14: redefining aa
line 16: expected `FIELD'
line 18: expected `FIELD'
line 19: expected `JOINING'
line 20: expected `FILE'
line 23: expected '(', got EOF
EOF
#
# there should be no test_11.scr file
#
if [ -f test_11.scr ]; then
	exit
fi
#
# Everything is OK
#
RC=0
